package com.ruoyi.models.service;

import java.util.List;
import com.ruoyi.models.domain.BizModule;

/**
 * 模块Service接口
 * 
 * @author ruoyi
 * @date 2025-08-28
 */
public interface IBizModuleService 
{
    /**
     * 查询模块
     * 
     * @param moduleId 模块主键
     * @return 模块
     */
    public BizModule selectBizModuleByModuleId(Long moduleId);

    /**
     * 查询模块列表
     * 
     * @param bizModule 模块
     * @return 模块集合
     */
    public List<BizModule> selectBizModuleList(BizModule bizModule);

    /**
     * 新增模块
     * 
     * @param bizModule 模块
     * @return 结果
     */
    public int insertBizModule(BizModule bizModule);

    /**
     * 修改模块
     * 
     * @param bizModule 模块
     * @return 结果
     */
    public int updateBizModule(BizModule bizModule);

    /**
     * 批量删除模块
     * 
     * @param moduleIds 需要删除的模块主键集合
     * @return 结果
     */
    public int deleteBizModuleByModuleIds(Long[] moduleIds);

    /**
     * 删除模块信息
     * 
     * @param moduleId 模块主键
     * @return 结果
     */
    public int deleteBizModuleByModuleId(Long moduleId);

    List<BizModule> selectByProjectId(long projectId);

    /**
     * 指派模块给用户
     * @param bizModule 模块信息
     * @return 结果
     */
    public int assignModule(BizModule bizModule);

    /**
     * 用户接取模块
     * @param moduleId 模块ID
     * @param userId 用户ID
     * @return 结果
     */
    public int receiveModule(Long moduleId, Long userId);

    /**
     * 用户放弃模块
     * @param moduleId 模块ID
     * @param userId 用户ID
     * @return 结果
     */
    public int abandonModule(Long moduleId, Long userId);

    /**
     * 查询用户被指派的模块列表
     * @param userId 用户ID
     * @return 模块集合
     */
    public List<BizModule> selectAssignedModules(Long userId);

    /**
     * 用户完成模块
     * @param moduleId 模块ID
     * @param userId 用户ID
     * @return 结果
     */
    public int completeModule(Long moduleId, Long userId);
}
